# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, langlib, os, gamethread
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
core    = es.import_addon('sam/core')
monitor = es.import_addon('sam/core/monitor')
admins  = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
tag       = '#yellowPROP SPAWNER'
cloud     = {'spawned':[],'worldspawn':True,'colors':'popup','cache':{},'deleting':False}
lastgive  = es.ServerVar('eventscripts_lastgive')
filesPath = es.getAddonPath('sam/addons/props')+'/props/'
colors = {'Reset Color':'255,255,255','Red':'255,0,0','Green':'0,255,0','Blue':'0,0,255','Black':'0,0,0','Brown':'150,100,0','Dark Red':'125,0,0',
		  'Gray':'175,175,175','Green':'0,125,0','Light Green':'0,255,0','Orange':'255,150,0','Pink':'255,0,255','Purple':'175,0,175',
		  'Red':'255,0,0','Turkey':'0,255,255','White':'255,255,255','Yellow':'255,255,0'}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# ADD MAIN PAGE OPTION
	core.addons.append('props')

	# CREATE COLORS MENU
	colorProp()

	# CMDS
	func.SayCMD('!props', propsCMD)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# REMOVE MAIN PAGE OPTION
	core.addons.remove('props')

	# CMDS
	func.unSayCMD('!props')

	# REMOVE PROPS
	if len(cloud['spawned']) and not cloud['deleting']: removeAll()
	del cloud['spawned']
	del cloud['cache']

	# POPUPS
	func.popupDelete('PROPS_MAIN')
	func.popupDelete('PROPS_MOVE')
	func.popupDelete('PROPS_COLOR')
	func.popupDelete('PROPS_ROTATE')
	func.popupDelete('PROPS_SPAWN_CATEGORYS')
	func.popupDelete('PROPS_SPAWN_OBJECTS')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID):
	if not ID in cloud['cache']: cloud['cache'][ID] = {'category':None,'s':1}
	popup = func.easymenu(('PROPS_MAIN', propsMain_Choice),'HOME')
	popup.settitle(func.header(monitor.get('props','name')))
	popup.addoption('spawn', func.langAddon('props','SPAWN_PROPS'))
	popup.addoption('del', '%s (%s)' % (func.langAddon('props','DELETE_PROPS'),func.langAddon('props','INFO_DEL')))
	popup.addoption('delAll',func.langAddon('props','DELETE_ALL_PROPS'))
	popup.addoption('move', func.langAddon('props','MOVE_PROPS'))
	popup.addoption('rotate', func.langAddon('props','ROTATE_PROPS'))
	popup.addoption('color', func.langAddon('props','COLOR_PROPS'))
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def propsMain_Choice(ID, CHOICE, POPUP):
	if   CHOICE == 'spawn':  spawnProp(ID)
	elif CHOICE == 'del':    delProp(ID)
	elif CHOICE == 'move':   moveProp(ID)
	elif CHOICE == 'rotate': rotateProp(ID)
	elif CHOICE == 'color':  cloud['colors'].send(ID)
	elif CHOICE == 'delAll':
		removeAll(ID)
		page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def spawnProp(ID, SEND=True):
	a   = getCategorys()
	num = 0
	for x in a: num += len(list(getProps(a[x])))
	popup = func.easymenu(('PROPS_SPAWN_CATEGORYS', propsSpawn1_Choice),'PROPS_MAIN')
	popup.settitle(func.header(monitor.get('props','name')))
	popup.setdescription('%s\n # Objects Tracked: %s\n # Objects Spawned: %s' % (func.line,num,len(cloud['spawned'])))
	for x in a: popup.addoption(a[x], x)
	if SEND: popup.send(ID)

# ------------------------------------------------------------------------------- #
def propsSpawn1_Choice(ID, CATEGORY, POPUP=False, PAGE=False):
	objects     = getProps(CATEGORY)
	objectsList = list(objects)
	popup = func.easymenu(('PROPS_SPAWN_OBJECTS', propsSpawn2_Choice),'PROPS_SPAWN_CATEGORYS')
	popup.settitle(func.header(monitor.get('props','name')+' (%s Objects)' % len(objectsList)))
	popup.setdescription(' # %s' % func.langAddon('props','INFO_SPAWN'))
	cloud['cache'][ID]['category'] = CATEGORY
	x = 0
	y = 0
	l = []
	for prop in objectsList:
		x += 1
		if x in (1, (y+6)):
			y = x
			l.append('rem%s'%y)
			popup.addoption('rem%s'%y, '< %s >' % func.langAddon('props', 'QUICK_REMOVE'))
		l.append(prop)
		popup.addoption(prop, prop)
	if PAGE: popup.sendPage(ID, func.sendPage(l.index(PAGE)))
	else: popup.send(ID)

# ------------------------------------------------------------------------------- #
def propsSpawn2_Choice(ID, PROP, POPUP):
	category = cloud['cache'][ID]['category']
	objects  = getProps(category)
	l        = list(objects)
	if not PROP.startswith('rem'):
		es.server.cmd('es_xprop_%s_create %s %s' % (objects[PROP]['type'],ID,objects[PROP]['path']))
		if lastgive:
			if not int(lastgive) in cloud['spawned']: cloud['spawned'].append(int(lastgive))
		spawnProp(ID, False)
	else: delProp(ID,False)
	propsSpawn1_Choice(ID, category, False, PROP)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def delProp(ID, SEND=True):
	index = getViewProp(ID)
	if isProp(index):
		if index in cloud['spawned']: cloud['spawned'].remove(index)
		es.server.cmd('es_xremove %s' % index)
		func.hudhint(ID, func.langAddon('props', 'PROP_DELETED'), tag)
	if SEND: page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def moveProp(ID):
	popup = func.easymenu(('PROPS_MOVE', propsMove_Choice),'PROPS_MAIN',False)
	popup.settitle(func.header(monitor.get('props','name')))
	popup.setdescription(' # %s' % func.langAddon('props','INFO_MOVE'))
	popup.addoption('+x', '%s [+x]' % func.langAddon('props','FORWARD'))
	popup.addoption('-x', '%s [-x]' % func.langAddon('props','BACK'))
	popup.addoption('+z', '%s [+z]' % func.langAddon('props','UP'))
	popup.addoption('-z', '%s [-z]' % func.langAddon('props','DOWN'))
	popup.addoption('+y', '%s [+y]' % func.langAddon('props','LEFT'))
	popup.addoption('-y', '%s [-y]' % func.langAddon('props','RIGHT'))
	popup.addoption('speed', '%s [ %s ]' % (func.langAddon('props','MOVE_SPEED'),cloud['cache'][ID]['s']))
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def propsMove_Choice(ID, CORD, POPUP):
	if not CORD == 'speed':
		cord  = CORD.strip(CORD[0])
		index = getViewProp(ID)
		if isProp(index):
			x,y,z = es.getindexprop(index, 'CBaseEntity.m_vecOrigin').split(',')
			speed = cloud['cache'][ID]['s'] * 10
			if CORD.startswith('+'):
				if   cord == 'x': x = float(x) + speed
				elif cord == 'y': y = float(y) + speed
				elif cord == 'z': z = float(z) + speed
			elif CORD.startswith('-'):
				if   cord == 'x': x = float(x) - speed
				elif cord == 'y': y = float(y) - speed
				elif cord == 'z': z = float(z) - speed
			es.entitysetvalue(index, 'origin', '%s %s %s' % (x, y, z))
		else: func.hudhint(ID, '%s\n(%s)' % (func.langAddon('props', 'PROP_NOT_VALID'),es.entitygetvalue(index, 'classname')), tag)
	else:
		if cloud['cache'][ID]['s'] < 5: cloud['cache'][ID]['s'] += 1
		else: cloud['cache'][ID]['s'] = 1
	moveProp(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rotateProp(ID):
	popup = func.easymenu(('PROPS_ROTATE', propsRotate_Choice),'PROPS_MAIN',False)
	popup.settitle(func.header(monitor.get('props','name')))
	popup.setdescription(' # %s' % func.langAddon('props','INFO_ROTATE'))
	popup.addoption(1, 'Yaw [+z]')
	popup.addoption(4, 'Yaw [-z]')
	popup.addoption(0, 'Pitch [+y]')
	popup.addoption(3, 'Pitch [-y]')
	popup.addoption(2, 'Roll [+x]')
	popup.addoption(5, 'Roll [-x]')
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def propsRotate_Choice(ID, CORD, POPUP):
	index = getViewProp(ID)
	if isProp(index):
		angles = es.entitygetvalue(index, 'angles').split()
		if   CORD in (0,1,2): angles[CORD]   = str(float(angles[CORD]) + 5)
		elif CORD in (3,4,5): angles[CORD-3] = str(float(angles[CORD-3]) - 5)
		es.entitysetvalue(index, 'angles', ' '.join(angles))
	else: func.hudhint(ID, '%s\n(%s)' % (func.langAddon('props', 'PROP_NOT_VALID'),es.entitygetvalue(index, 'classname')), tag)
	rotateProp(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def colorProp():
	cloud['colors'] = func.easymenu(('PROPS_COLOR', propsColor_Choice),'PROPS_MAIN',False)
	cloud['colors'].settitle(func.header(monitor.get('props','name')))
	cloud['colors'].setdescription(' # %s' % func.langAddon('props','INFO_COLOR'))
	cloud['colors'].addoption('Reset Color', func.langAddon('props', 'RESET_COLOR'))
	for c in colors:
		if not c == 'Reset Color': cloud['colors'].addoption(c, c)

# ------------------------------------------------------------------------------- #
def propsColor_Choice(ID, COLOR, POPUP):
	index = getViewProp(ID)
	if isProp(index):
		r,g,b = colors[COLOR].split(',')
		color = int(r) + (int(g) << 8) + (int(b) << 16) + (255 << 24)
		if color >= 2**31: color -= 2**32
		es.setindexprop(index, "CBaseEntity.m_nRenderMode", es.getindexprop(index, "CBaseEntity.m_nRenderMode") | 1)
		es.setindexprop(index, "CBaseEntity.m_nRenderFX", es.getindexprop(index, "CBaseEntity.m_nRenderFX") | 256)
		es.setindexprop(index, "CBaseEntity.m_clrRender", color)
		if COLOR == 'Reset Color': func.hudhint(ID, func.langAddon('props', 'COLOR_RESET'), tag)
		else: func.hudhint(ID, func.langAddon('props', 'PROP_COLOR_CHANGE', {'color':COLOR}), tag)
	else: func.hudhint(ID, '%s\n(%s)' % (func.langAddon('props', 'PROP_NOT_VALID'),es.entitygetvalue(index, 'classname')), tag)
	cloud['colors'].send(ID)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getViewProp(ID):
	entnames = {}
	name     = '%s_target_prop' % ID
	entList  = es.createentitylist()
	for x in entList: entnames[x] = es.entitygetvalue(x, 'targetname')
	es.entsetname(ID, name)
	entList = es.createentitylist()
	for x in entList:
	 	if es.entitygetvalue(x, 'targetname') == name:
			es.entitysetvalue(x, 'targetname', entnames[x])
			return int(x)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getEntList():
	full = es.createentityindexlist()
	return [x for x in full if isProp(x)]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def isProp(INDEX):
	if es.entitygetvalue(INDEX, 'classname').startswith('prop_') or es.entitygetvalue(INDEX, 'classname').startswith('func_ill'): return True
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getCategorys():
	files = [x for x in os.listdir(filesPath) if x.endswith('.ini')]
	temp  = {}
	for x in files:
		name = x.replace('_',' ').replace('.ini','')
		temp[name] = x
	return temp

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getProps(CATEGORY): return langlib.Strings(filesPath+CATEGORY)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def removeAll(ID=False):
	if len(cloud['spawned']):
		cloud['deleting'] = True
		entList = es.createentitylist()
		num = 0.1
		while len(cloud['spawned']) != 0:
			for index in cloud['spawned']:
				if index in entList:
					if not es.entitygetvalue(index, 'classname') == 'worldspawn': gamethread.delayed(num, es.server.cmd,('es_xremove %s' % index))
				cloud['spawned'].remove(index)
				gamethread.delayed(num, func.hudhint,('#all', func.langAddon('props','DELETING_PROPS',{'num':len(cloud['spawned'])}), tag))
				num += 0.1
		cloud['deleting'] = False
	elif ID: func.hudhint(ID, func.langAddon('props','NO_PROPS_SPAWNED'), tag)

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def propsCMD(ID, ARGS):
	if admins.can(ID, 'Prop Spawning'): page(ID)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_disconnect(ev):
	if ev['userid'] in cloud['cache']: del cloud['cache'][ev['userid']]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_end(ev): cloud['spawned'] = []

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def es_map_start(ev): cloud['spawned'] = []

# =============================================================================== #